# TOTVS Logística Mobile Foundation

Biblioteca com recursos que auxiliam o desenvolvimento de aplicativos Mobile utilizando Ionic + Angular.

## Recursos disponíveis:

### Serviços:

* Autenticação (com TOTVS RAC);
* Formatação de Data/Hora;
* Interceptador de requisições para injeção do Token;
* Internacionalização;
* Mensagens;
* Loading;
* Multi-Tenant;
* Serviço global (com Internacionalização, Mensagens e Loading);

### Utilitários para plugins:

* Câmera;
* Manipulação de arquivos;
* Geolocalização;
* Galeria de imagens;
* OIDC (Popup para autenticação OAuth2);
* Leitura de QR-Code;
* Reconhecimento de voz em texto;
* Banco de dados SQLite;
* Storage do navegador;

### Sincronização de dados

* Configuração de sincronização;
* Padrão de implementação de serviços para comunicação com backend;
* Armazenamento de dados utilizando SQLite;

## Autor

[**TOTVS**](https://totvs.com.br) - *Supply Chain - Suíte Logística*