(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('totvs-log-base-foundation'), require('@ionic/angular'), require('@angular/core'), require('@ionic-native/http/ngx')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/http-util', ['exports', 'totvs-log-base-foundation', '@ionic/angular', '@angular/core', '@ionic-native/http/ngx'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['http-util'] = {}),global.totvsLogBaseFoundation,global.angular,global.ng.core,global.ngx));
}(this, (function (exports,totvsLogBaseFoundation,angular,core,ngx) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO - Verificar se é válido ter classes abstratas para os utilitários
    /**
     * Utilitário para auxiliar o desenvolvimento utilizando o plugin de requisição http
     * nativa do dispositivo com métodos que facilitam a utilização do plugin
     */
    var HttpOauth2UtilProvider = /** @class */ (function () {
        /**
         * @ignore
         * Método construtor responsável por inicializar o serviço
         * platform Serviço relacionado a plataforma
         * file Serviço do plugin nativo de arquivo
         * events Serviço de eventos do Ionic
         */
        function HttpOauth2UtilProvider(platform, auth, http) {
            var _this = this;
            this.auth = auth;
            this.http = http;
            /**
             * @ignore
             * Indica se a plataforma é cordova
             */
            this.isCordova = false;
            platform.ready().then(( /**
             * @return {?}
             */function () { return _this.isCordova = platform.is('cordova'); }));
        }
        /**
         * Método responsável por realizar o upload de um arquivo
         * @template T Objeto de resposta do servidor quando sucesso
         * url URL do Endpoint de Upload
         * filePath URI do arquivo no dispositivo
         * name Nome do arquivo
         * body Informações no corpo da mensagem
         * headers Informações de cabeçalho da mensagem
         * {IHttpUtilResult} Resultado da requisição
         */
        /**
         * Método responsável por realizar o upload de um arquivo
         * url URL do Endpoint de Upload
         * filePath URI do arquivo no dispositivo
         * name Nome do arquivo
         * body Informações no corpo da mensagem
         * headers Informações de cabeçalho da mensagem
         * {IHttpUtilResult} Resultado da requisição
         * @template T
         * @param {?} url
         * @param {?} filePath
         * @param {?=} name
         * @param {?=} body
         * @param {?=} headers
         * @return {?}
         */
        HttpOauth2UtilProvider.prototype.uploadFile = /**
         * Método responsável por realizar o upload de um arquivo
         * url URL do Endpoint de Upload
         * filePath URI do arquivo no dispositivo
         * name Nome do arquivo
         * body Informações no corpo da mensagem
         * headers Informações de cabeçalho da mensagem
         * {IHttpUtilResult} Resultado da requisição
         * @template T
         * @param {?} url
         * @param {?} filePath
         * @param {?=} name
         * @param {?=} body
         * @param {?=} headers
         * @return {?}
         */
            function (url, filePath, name, body, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var user, postHeaders, postBody, result, response, error_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (this.isCordova === false) {
                                    throw new totvsLogBaseFoundation.CriticalError('Platform is not cordova (uploadFile)');
                                }
                                url = url.replace('{tenant}', this.auth.shortNameTenant || '');
                                // Injeção da autorização Oauth2
                                return [4 /*yield*/, this.auth.getUser()];
                            case 1:
                                user = _a.sent();
                                if (headers) {
                                    postHeaders = Object.assign({}, headers, {
                                        Authorization: user ? user.token_type + " " + user.access_token : ''
                                    });
                                }
                                else {
                                    postHeaders = {
                                        Authorization: user ? user.token_type + " " + user.access_token : ''
                                    };
                                }
                                if (body) {
                                    postBody = body;
                                }
                                else {
                                    postBody = {};
                                }
                                if (name === undefined || name === '') {
                                    name = 'file';
                                }
                                result = {
                                    status: 0,
                                    data: undefined,
                                    error: undefined,
                                    sourceResponse: undefined
                                };
                                _a.label = 2;
                            case 2:
                                _a.trys.push([2, 4, , 5]);
                                return [4 /*yield*/, this.http.uploadFile(url, postBody, postHeaders, filePath, name)];
                            case 3:
                                response = _a.sent();
                                result.sourceResponse = response;
                                if (response) {
                                    if (response.hasOwnProperty('status')) {
                                        result.status = response.status;
                                    }
                                    if (response.hasOwnProperty('data')) {
                                        try {
                                            result.data = ( /** @type {?} */(JSON.parse(response.data)));
                                        }
                                        catch (error) {
                                            result.error = error;
                                        }
                                    }
                                }
                                return [3 /*break*/, 5];
                            case 4:
                                error_1 = _a.sent();
                                result.error = error_1;
                                return [3 /*break*/, 5];
                            case 5: return [2 /*return*/, result];
                        }
                    });
                });
            };
        /**
         * Método que permite a alteração do modo de verificação do certificado SSL
         * mode Modo de verificação do certificado SSL
         */
        /**
         * Método que permite a alteração do modo de verificação do certificado SSL
         * mode Modo de verificação do certificado SSL
         * @param {?} mode
         * @return {?}
         */
        HttpOauth2UtilProvider.prototype.setSSLCertMode = /**
         * Método que permite a alteração do modo de verificação do certificado SSL
         * mode Modo de verificação do certificado SSL
         * @param {?} mode
         * @return {?}
         */
            function (mode) {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.http.setSSLCertMode(mode)];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    });
                });
            };
        HttpOauth2UtilProvider.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        HttpOauth2UtilProvider.ctorParameters = function () {
            return [
                { type: angular.Platform },
                { type: totvsLogBaseFoundation.AuthBaseService },
                { type: ngx.HTTP }
            ];
        };
        return HttpOauth2UtilProvider;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que contém um provedor utilitário que auxilia na
     * utilização do plugin nativo de requisição http
     */
    var HttpOauth2UtilModule = /** @class */ (function () {
        function HttpOauth2UtilModule() {
        }
        HttpOauth2UtilModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: [
                            ngx.HTTP,
                            HttpOauth2UtilProvider
                        ]
                    },] }
        ];
        return HttpOauth2UtilModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.HttpOauth2UtilModule = HttpOauth2UtilModule;
    exports.HttpOauth2UtilProvider = HttpOauth2UtilProvider;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-http-util.umd.js.map