import { IWebI18nLanguage } from './web-i18n-language.interface';
/**
 * Responsável pelos atributos de configuração do serviço de internacionalização
 */
export interface IIntlConfig {
    /**
     * Indica se o serviço de internacionalização não deve carregar os dados na inicialização.
     */
    lazy?: boolean;
    /**
     * Indica os idiomas suportados pela aplicação
     */
    supportedLanguages?: Array<IWebI18nLanguage>;
}
