/**
 * Interface que representa a resposta da requisição Http nativa
 */
export interface IHttpUtilResult<T> {
    /** Código HTTP de resposta */
    status: number;
    /** Objeto de resposta quando sucesso */
    data: T;
    /** Erro da requisição */
    error: any;
    /** Resposta origem */
    sourceResponse: any;
}
