import { OidcCordovaPopupWindow } from './oidc-cordova-popup-window';
import { InAppBrowser } from '@ionic-native/in-app-browser/ngx';
/**
 * Classe responsável pelo Iframe utilizado no processo
 * de autenticação com Oidc no Ionic
 */
export declare class OidcCordovaIFrameNavigator {
    private iab;
    /**
     * Método construtor que inicializa a classe
     * iab Serviço do plugin nativo InAppBrowser
     */
    constructor(iab: InAppBrowser);
    /**
     * Método que prepara a janela de popup
     * params Parâmetros para a janela de popup
     */
    prepare(params: any): Promise<OidcCordovaPopupWindow>;
}
