import { ISyncWatch } from './sync-watch.interface';
import { ISyncEntity } from './sync-entity.interface';
/**
 * Interface de configuração de sincronização
 */
export interface ISyncConfig {
    /**
     * Nome do banco de dados de armazenamento
     */
    dbStorageName: string;
    /**
     * Configuração do monitoramento automático
     */
    autoWatch?: ISyncWatch;
    /**
     * As entidades que serão sincronizadas
     */
    entities: ISyncEntity[];
}
