import { StatusBar } from '@ionic-native/status-bar/ngx';
/**
 * Esta classe simula a classe StatusBar e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: StatusBar, useClass: StatusBarMock},
 *   ...
 * ]
 * ```
 */
export declare class StatusBarMock extends StatusBar {
    /**
     * Método que simula o retorno do estilo padrão
     */
    styleDefault(): void;
}
