(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('totvs-log-mobile-foundation'), require('totvs-log-base-foundation'), require('@ionic/angular'), require('@ionic-native/image-picker/ngx'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/image-picker-util', ['exports', 'totvs-log-mobile-foundation', 'totvs-log-base-foundation', '@ionic/angular', '@ionic-native/image-picker/ngx', '@angular/core'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['image-picker-util'] = {}),global['totvs-log-mobile-foundation'],global.totvsLogBaseFoundation,global.angular,global.ngx,global.ng.core));
}(this, (function (exports,totvsLogMobileFoundation,totvsLogBaseFoundation,angular,ngx,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que contém os eventos que o utilitário assina e publica
     */
    var ImagePickerUtilEvents = /** @class */ (function () {
        function ImagePickerUtilEvents() {
        }
        // FIXME - Nomes de eventos mais específicos, para evitar possíveis conflitos
        /**
         * Evento publicado pelo utilitário quando uma ou mais imagens são
         * selecionadas e geram uma cópia no cache do aplicativo
         */
        ImagePickerUtilEvents.CACHE_FILE_CREATED = 'CacheFile:Created';
        return ImagePickerUtilEvents;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO - Verificar se é válido ter classes abstratas para os utilitários
    /**
     * Utilitário para auxiliar o desenvolvimento utilizando o plugin de seleção
     * de imagens do dispositivo com métodos que facilitam a solicitação de permissão,
     * apresentação e seleção de imagens
     */
    var ImagePickerUtilProvider = /** @class */ (function () {
        /**
         * @ignore
         * Método responsável por construir o serviço
         * platform Serviço relacionado a plataforma
         * imagePicker Serviço do plugin nativo de galeria
         * global Serviço global da aplicação
         */
        function ImagePickerUtilProvider(platform, imagePicker, global, events) {
            var _this = this;
            this.imagePicker = imagePicker;
            this.global = global;
            this.events = events;
            /**
             * @ignore
             * Indica se a plataforma é cordova
             */
            this.isCordova = false;
            /**
             * @ignore
             * Opções padrões para a galeria
             */
            this.defaultOptions = {
                outputType: ngx.OutputType.FILE_URL,
                quality: 60
            };
            platform.ready().then(( /**
             * @return {?}
             */function () { return _this.isCordova = platform.is('cordova'); }));
        }
        /**
         * Método responsável por abrir o seletor de imagens e retornar o caminho dos arquivos salvos no cache
         * Este método publica o evento ImagePickerUtilEvents.CACHE_FILE_CREATED quando um ou mais arquivos são selecionados
         * e criados em cache (Mais informações sobre eventos {@link https://ionicframework.com/docs/api/util/Events/|Ionic Events})
         * opt Customização das opções enviadas ao seletor de images
         * Lista de imagens escolhidas
         */
        /**
         * Método responsável por abrir o seletor de imagens e retornar o caminho dos arquivos salvos no cache
         * Este método publica o evento ImagePickerUtilEvents.CACHE_FILE_CREATED quando um ou mais arquivos são selecionados
         * e criados em cache (Mais informações sobre eventos {\@link https://ionicframework.com/docs/api/util/Events/|Ionic Events})
         * opt Customização das opções enviadas ao seletor de images
         * Lista de imagens escolhidas
         * @param {?=} opt
         * @return {?}
         */
        ImagePickerUtilProvider.prototype.chooseImage = /**
         * Método responsável por abrir o seletor de imagens e retornar o caminho dos arquivos salvos no cache
         * Este método publica o evento ImagePickerUtilEvents.CACHE_FILE_CREATED quando um ou mais arquivos são selecionados
         * e criados em cache (Mais informações sobre eventos {\@link https://ionicframework.com/docs/api/util/Events/|Ionic Events})
         * opt Customização das opções enviadas ao seletor de images
         * Lista de imagens escolhidas
         * @param {?=} opt
         * @return {?}
         */
            function (opt) {
                return __awaiter(this, void 0, void 0, function () {
                    var e_1, _a, _b, msg, images, options, _c, _d, prop, hasPermission, msg, error_1;
                    return __generator(this, function (_e) {
                        switch (_e.label) {
                            case 0:
                                if (this.isCordova === false) {
                                    msg = new totvsLogBaseFoundation.BaseMessage({
                                        literal: 'recursoNaoEstaDisponivelMsg'
                                    });
                                    this.global.msg.showMessage(msg);
                                    throw new totvsLogBaseFoundation.CriticalError('Platform is not cordova');
                                }
                                images = [];
                                _e.label = 1;
                            case 1:
                                _e.trys.push([1, 6, , 7]);
                                options = Object.assign({}, this.defaultOptions);
                                if (opt) {
                                    try {
                                        for (_c = __values(Object.keys(opt)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                            prop = _d.value;
                                            options[prop] = opt[prop];
                                        }
                                    }
                                    catch (e_1_1) {
                                        e_1 = { error: e_1_1 };
                                    }
                                    finally {
                                        try {
                                            if (_d && !_d.done && (_a = _c.return))
                                                _a.call(_c);
                                        }
                                        finally {
                                            if (e_1)
                                                throw e_1.error;
                                        }
                                    }
                                }
                                return [4 /*yield*/, this.requestReadPermission()];
                            case 2:
                                hasPermission = _e.sent();
                                if (!hasPermission)
                                    return [3 /*break*/, 4];
                                return [4 /*yield*/, this.imagePicker.getPictures(options)];
                            case 3:
                                images = _e.sent();
                                (_b = this.events).publish.apply(_b, __spread([ImagePickerUtilEvents.CACHE_FILE_CREATED], images));
                                return [3 /*break*/, 5];
                            case 4:
                                msg = new totvsLogBaseFoundation.BaseMessage({
                                    literal: 'permissaoNaoConcedidaParaORecursoMsg'
                                });
                                this.global.msg.showMessage(msg);
                                throw new totvsLogBaseFoundation.CriticalError('Permission denied');
                            case 5: return [3 /*break*/, 7];
                            case 6:
                                error_1 = _e.sent();
                                throw new totvsLogBaseFoundation.CriticalError('Error in get pictures', error_1);
                            case 7: return [2 /*return*/, images];
                        }
                    });
                });
            };
        /**
         * Método responsável por requisitar permissão para acesso a galeria
         * Indicação se possui ou não permissão
         */
        /**
         * Método responsável por requisitar permissão para acesso a galeria
         * Indicação se possui ou não permissão
         * @return {?}
         */
        ImagePickerUtilProvider.prototype.requestReadPermission = /**
         * Método responsável por requisitar permissão para acesso a galeria
         * Indicação se possui ou não permissão
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    var hasPermission, permission, permissionAfterRequest, error_2;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                hasPermission = false;
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 7, , 8]);
                                return [4 /*yield*/, this.imagePicker.hasReadPermission()];
                            case 2:
                                permission = _a.sent();
                                if (!!permission)
                                    return [3 /*break*/, 5];
                                return [4 /*yield*/, this.imagePicker.requestReadPermission()];
                            case 3:
                                _a.sent();
                                return [4 /*yield*/, this.imagePicker.hasReadPermission()];
                            case 4:
                                permissionAfterRequest = _a.sent();
                                hasPermission = permissionAfterRequest;
                                return [3 /*break*/, 6];
                            case 5:
                                hasPermission = true;
                                _a.label = 6;
                            case 6: return [3 /*break*/, 8];
                            case 7:
                                error_2 = _a.sent();
                                hasPermission = false;
                                return [3 /*break*/, 8];
                            case 8: return [2 /*return*/, hasPermission];
                        }
                    });
                });
            };
        ImagePickerUtilProvider.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ImagePickerUtilProvider.ctorParameters = function () {
            return [
                { type: angular.Platform },
                { type: ngx.ImagePicker },
                { type: totvsLogMobileFoundation.GlobalService },
                { type: angular.Events }
            ];
        };
        return ImagePickerUtilProvider;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que contém um provedor utilitário que auxilia na
     * utilização do plugin nativo de galeria
     */
    var ImagePickerUtilModule = /** @class */ (function () {
        function ImagePickerUtilModule() {
        }
        ImagePickerUtilModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: [
                            ngx.ImagePicker,
                            ImagePickerUtilProvider
                        ]
                    },] }
        ];
        return ImagePickerUtilModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ImagePickerUtilEvents = ImagePickerUtilEvents;
    exports.ImagePickerUtilModule = ImagePickerUtilModule;
    exports.ImagePickerUtilProvider = ImagePickerUtilProvider;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-image-picker-util.umd.js.map