(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('totvs-log-base-foundation'), require('@ionic/angular'), require('@ionic-native/sqlite/ngx'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/sqlite-util', ['exports', 'totvs-log-base-foundation', '@ionic/angular', '@ionic-native/sqlite/ngx', '@angular/core'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['sqlite-util'] = {}),global.totvsLogBaseFoundation,global.angular,global.ngx,global.ng.core));
}(this, (function (exports,totvsLogBaseFoundation,angular,ngx,core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Gerenciador de conexão de banco de dados sqlite
     * @abstract
     */
    var /**
     * Gerenciador de conexão de banco de dados sqlite
     * @abstract
     */ SqLiteUtilBaseProvider = /** @class */ (function () {
        function SqLiteUtilBaseProvider(sqlLite, platform) {
            this.sqlLite = sqlLite;
            this.platform = platform;
        }
        /**
         * Método para auxiliar a criar uma conexão com o banco sqlite
         * name Nome do banco
         * location Localização do banco
         * DbConnectionBaseProvider
         */
        /**
         * Método para auxiliar a criar uma conexão com o banco sqlite
         * name Nome do banco
         * location Localização do banco
         * DbConnectionBaseProvider
         * @protected
         * @param {?} name
         * @param {?} location
         * @return {?}
         */
        SqLiteUtilBaseProvider.prototype.createConn = /**
         * Método para auxiliar a criar uma conexão com o banco sqlite
         * name Nome do banco
         * location Localização do banco
         * DbConnectionBaseProvider
         * @protected
         * @param {?} name
         * @param {?} location
         * @return {?}
         */
            function (name, location) {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.platform.ready()];
                            case 1:
                                _a.sent();
                                return [2 /*return*/, this.sqlLite.create({ name: name, location: location })];
                        }
                    });
                });
            };
        return SqLiteUtilBaseProvider;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Gerenciador de conexão de banco de dados sqlite
     */
    var SqLiteUtilProvider = /** @class */ (function (_super) {
        __extends(SqLiteUtilProvider, _super);
        function SqLiteUtilProvider(sqlLite, platform) {
            var _this = _super.call(this, sqlLite, platform) || this;
            _this.connections = new Array();
            _this.creating = new Array();
            return _this;
        }
        /**
         * Recupera uma conexão de banco de dados
         *
         * name o banco de dados desejado
         * {string} [location='default'] Configuração adicional de localização no dispositivo
         * @returns Um objeto de conexão com o banco
         */
        /**
         * Recupera uma conexão de banco de dados
         *
         * name o banco de dados desejado
         * {string} [location='default'] Configuração adicional de localização no dispositivo
         * @param {?} name
         * @param {?=} location
         * @return {?} Um objeto de conexão com o banco
         */
        SqLiteUtilProvider.prototype.getSqLiteConn = /**
         * Recupera uma conexão de banco de dados
         *
         * name o banco de dados desejado
         * {string} [location='default'] Configuração adicional de localização no dispositivo
         * @param {?} name
         * @param {?=} location
         * @return {?} Um objeto de conexão com o banco
         */
            function (name, location) {
                if (location === void 0) {
                    location = 'default';
                }
                return __awaiter(this, void 0, void 0, function () {
                    var element, sqlConn, idx;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, totvsLogBaseFoundation.UtilsFn.lock(( /**
                                     * @return {?}
                                     */function () {
                                    return _this.creating.find(( /**
                                     * @param {?} x
                                     * @return {?}
                                     */function (x) { return x.name === name && x.location === location; }));
                                }))];
                            case 1:
                                _a.sent();
                                element = this.connections.find(( /**
                                 * @param {?} x
                                 * @return {?}
                                 */function (x) { return x.name === name && x.location === location; }));
                                if (!!element)
                                    return [3 /*break*/, 3];
                                this.creating.push({ name: name, location: location, conn: undefined });
                                return [4 /*yield*/, this.createConn(name, location)];
                            case 2:
                                sqlConn = _a.sent();
                                this.connections.push({ name: name, location: location, conn: sqlConn });
                                idx = this.creating.findIndex(( /**
                                 * @param {?} x
                                 * @return {?}
                                 */function (x) { return x.name === name && x.location === location; }));
                                if (idx !== -1) {
                                    this.creating.splice(idx, 1);
                                }
                                return [3 /*break*/, 4];
                            case 3:
                                sqlConn = element.conn;
                                _a.label = 4;
                            case 4: return [2 /*return*/, sqlConn];
                        }
                    });
                });
            };
        SqLiteUtilProvider.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        SqLiteUtilProvider.ctorParameters = function () {
            return [
                { type: ngx.SQLite },
                { type: angular.Platform }
            ];
        };
        return SqLiteUtilProvider;
    }(SqLiteUtilBaseProvider));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que controla as conexões com banco sqlite
     * e provê conexão com o serviço SqLite
     * Usar SqLiteUtilModule.forRoot() ao importar
     * @export
     * SqLiteUtilModule
     */
    var SqLiteUtilModule = /** @class */ (function () {
        function SqLiteUtilModule() {
        }
        /**
         * @return {?}
         */
        SqLiteUtilModule.forRoot = /**
         * @return {?}
         */
            function () {
                return {
                    ngModule: SqLiteUtilModule,
                    providers: [
                        ngx.SQLite,
                        {
                            provide: SqLiteUtilBaseProvider,
                            useClass: SqLiteUtilProvider
                        }
                    ]
                };
            };
        SqLiteUtilModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: []
                    },] }
        ];
        return SqLiteUtilModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.SqLiteUtilBaseProvider = SqLiteUtilBaseProvider;
    exports.SqLiteUtilProvider = SqLiteUtilProvider;
    exports.SqLiteUtilModule = SqLiteUtilModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-sqlite-util.umd.js.map