(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ionic/angular'), require('@ionic-native/status-bar/ngx'), require('@ionic-native/splash-screen/ngx'), require('rxjs'), require('totvs-log-base-foundation')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/test-utils', ['exports', '@angular/core', '@ionic/angular', '@ionic-native/status-bar/ngx', '@ionic-native/splash-screen/ngx', 'rxjs', 'totvs-log-base-foundation'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['test-utils'] = {}),global.ng.core,global.angular,global.ngx,global.ngx$1,global.rxjs,global.totvsLogBaseFoundation));
}(this, (function (exports,core,angular,ngx,ngx$1,rxjs,totvsLogBaseFoundation) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Esta classe simula a classe Platform e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: Platform, useClass: PlatformMock},
     *   ...
     * ]
     * ```
     */
    var /**
     * Esta classe simula a classe Platform e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: Platform, useClass: PlatformMock},
     *   ...
     * ]
     * ```
     */ PlatformMock = /** @class */ (function () {
        function PlatformMock() {
        }
        /**
         * Método que simula a ação de preparado da plataforma
         */
        /**
         * Método que simula a ação de preparado da plataforma
         * @return {?}
         */
        PlatformMock.prototype.ready = /**
         * Método que simula a ação de preparado da plataforma
         * @return {?}
         */
            function () {
                return new Promise(( /**
                 * @param {?} resolve
                 * @return {?}
                 */function (resolve) {
                    resolve('READY');
                }));
            };
        /**
         * Método que simula o retorno dos parâmetros de query de URL
         */
        /**
         * Método que simula o retorno dos parâmetros de query de URL
         * @return {?}
         */
        PlatformMock.prototype.getQueryParam = /**
         * Método que simula o retorno dos parâmetros de query de URL
         * @return {?}
         */
            function () {
                return true;
            };
        /**
         * Método que simula o registro da ação para o botão 'Voltar'
         * fn
         * priority
         */
        /**
         * Método que simula o registro da ação para o botão 'Voltar'
         * fn
         * priority
         * @param {?} fn
         * @param {?=} priority
         * @return {?}
         */
        PlatformMock.prototype.registerBackButtonAction = /**
         * Método que simula o registro da ação para o botão 'Voltar'
         * fn
         * priority
         * @param {?} fn
         * @param {?=} priority
         * @return {?}
         */
            function (fn, priority) {
                return (( /**
                 * @return {?}
                 */function () { return true; }));
            };
        /**
         * Método que simula a verificação de foco
         * ele
         */
        /**
         * Método que simula a verificação de foco
         * ele
         * @param {?} ele
         * @return {?}
         */
        PlatformMock.prototype.hasFocus = /**
         * Método que simula a verificação de foco
         * ele
         * @param {?} ele
         * @return {?}
         */
            function (ele) {
                return true;
            };
        /**
         * Método que simula o retorno do 'document'
         */
        /**
         * Método que simula o retorno do 'document'
         * @return {?}
         */
        PlatformMock.prototype.doc = /**
         * Método que simula o retorno do 'document'
         * @return {?}
         */
            function () {
                return document;
            };
        /**
         * Método que simula o retorno do 'is'
         */
        /**
         * Método que simula o retorno do 'is'
         * @return {?}
         */
        PlatformMock.prototype.is = /**
         * Método que simula o retorno do 'is'
         * @return {?}
         */
            function () {
                return true;
            };
        /**
         * Método que simula o retorno do estilo de um elemento
         * container
         */
        /**
         * Método que simula o retorno do estilo de um elemento
         * container
         * @param {?} container
         * @return {?}
         */
        PlatformMock.prototype.getElementComputedStyle = /**
         * Método que simula o retorno do estilo de um elemento
         * container
         * @param {?} container
         * @return {?}
         */
            function (container) {
                return {
                    paddingLeft: '10',
                    paddingTop: '10',
                    paddingRight: '10',
                    paddingBottom: '10',
                };
            };
        /**
         * Método que simula o evento de redimensionamento de tela
         * callback
         */
        /**
         * Método que simula o evento de redimensionamento de tela
         * callback
         * @param {?} callback
         * @return {?}
         */
        PlatformMock.prototype.onResize = /**
         * Método que simula o evento de redimensionamento de tela
         * callback
         * @param {?} callback
         * @return {?}
         */
            function (callback) {
                return callback;
            };
        /**
         * Método que simula o registro de evento de escuta
         * ele
         * eventName
         * callback
         */
        /**
         * Método que simula o registro de evento de escuta
         * ele
         * eventName
         * callback
         * @param {?} ele
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
        PlatformMock.prototype.registerListener = /**
         * Método que simula o registro de evento de escuta
         * ele
         * eventName
         * callback
         * @param {?} ele
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
            function (ele, eventName, callback) {
                return (( /**
                 * @return {?}
                 */function () { return true; }));
            };
        /**
         * Método que simula o retorno do método 'win'
         */
        /**
         * Método que simula o retorno do método 'win'
         * @return {?}
         */
        PlatformMock.prototype.win = /**
         * Método que simula o retorno do método 'win'
         * @return {?}
         */
            function () {
                return window;
            };
        /**
         * Método que simula o retorno do método 'raf'
         * callback
         */
        /**
         * Método que simula o retorno do método 'raf'
         * callback
         * @param {?} callback
         * @return {?}
         */
        PlatformMock.prototype.raf = /**
         * Método que simula o retorno do método 'raf'
         * callback
         * @param {?} callback
         * @return {?}
         */
            function (callback) {
                return 1;
            };
        /**
         * Método que simula a definição de tempo de espera
         * callback
         * timer
         */
        /**
         * Método que simula a definição de tempo de espera
         * callback
         * timer
         * @param {?} callback
         * @param {?} timer
         * @return {?}
         */
        PlatformMock.prototype.timeout = /**
         * Método que simula a definição de tempo de espera
         * callback
         * timer
         * @param {?} callback
         * @param {?} timer
         * @return {?}
         */
            function (callback, timer) {
                return setTimeout(callback, timer);
            };
        /**
         * Método que simula o cancelamento do tempo de espera
         * id
         */
        /**
         * Método que simula o cancelamento do tempo de espera
         * id
         * @param {?} id
         * @return {?}
         */
        PlatformMock.prototype.cancelTimeout = /**
         * Método que simula o cancelamento do tempo de espera
         * id
         * @param {?} id
         * @return {?}
         */
            function (id) {
                // do nothing
            };
        /**
         * Método que simula o retorno do elemento ativo
         */
        /**
         * Método que simula o retorno do elemento ativo
         * @return {?}
         */
        PlatformMock.prototype.getActiveElement = /**
         * Método que simula o retorno do elemento ativo
         * @return {?}
         */
            function () {
                return document.activeElement;
            };
        return PlatformMock;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe fictícia que serve para realizar os testes automatizados
     */
    var /**
     * Classe fictícia que serve para realizar os testes automatizados
     */ EmptyMock = /** @class */ (function () {
        function EmptyMock() {
        }
        return EmptyMock;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Esta classe simula a classe DeepLinker e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: DeepLinker, useClass: DeepLinkerMock},
     *   ...
     * ]
     * ```
     */
    var /**
     * Esta classe simula a classe DeepLinker e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: DeepLinker, useClass: DeepLinkerMock},
     *   ...
     * ]
     * ```
     */ DeepLinkerMock = /** @class */ (function () {
        function DeepLinkerMock() {
        }
        return DeepLinkerMock;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Esta classe simula a classe NavParams e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: NavParams, useClass: NavParamsMock},
     *   ...
     * ]
     * ```
     */
    var NavParamsMock = /** @class */ (function () {
        function NavParamsMock() {
        }
        /**
         * Método que simula a definição de parâmetros
         * value
         */
        /**
         * Método que simula a definição de parâmetros
         * value
         * @param {?} value
         * @return {?}
         */
        NavParamsMock.setParams = /**
         * Método que simula a definição de parâmetros
         * value
         * @param {?} value
         * @return {?}
         */
            function (value) {
                NavParamsMock.returnParam = value;
            };
        /**
         * Método que simula o retorno do valor de uma chave
         * key
         */
        /**
         * Método que simula o retorno do valor de uma chave
         * key
         * @param {?} key
         * @return {?}
         */
        NavParamsMock.prototype.get = /**
         * Método que simula o retorno do valor de uma chave
         * key
         * @param {?} key
         * @return {?}
         */
            function (key) {
                if (NavParamsMock.returnParam) {
                    return NavParamsMock.returnParam;
                }
                return 'default';
            };
        /**
         * Parâmetro de retorno
         */
        NavParamsMock.returnParam = null;
        return NavParamsMock;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Esta classe simula a classe Nav e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: Nav, useClass: NavMock},
     *   ...
     * ]
     * ```
     */
    var /**
     * Esta classe simula a classe Nav e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: Nav, useClass: NavMock},
     *   ...
     * ]
     * ```
     */ NavMock = /** @class */ (function () {
        function NavMock() {
        }
        /**
         * Método que simula o retorno de uma página
         */
        /**
         * Método que simula o retorno de uma página
         * @return {?}
         */
        NavMock.prototype.pop = /**
         * Método que simula o retorno de uma página
         * @return {?}
         */
            function () {
                return new Promise(( /**
                 * @param {?} resolve
                 * @return {?}
                 */function (resolve) {
                    resolve();
                }));
            };
        /**
         * Método que simula a navegação de uma página
         */
        /**
         * Método que simula a navegação de uma página
         * @return {?}
         */
        NavMock.prototype.push = /**
         * Método que simula a navegação de uma página
         * @return {?}
         */
            function () {
                return new Promise(( /**
                 * @param {?} resolve
                 * @return {?}
                 */function (resolve) {
                    resolve();
                }));
            };
        /**
         * Método que simula o retorno da página ativa
         */
        /**
         * Método que simula o retorno da página ativa
         * @return {?}
         */
        NavMock.prototype.getActive = /**
         * Método que simula o retorno da página ativa
         * @return {?}
         */
            function () {
                return {
                    instance: {
                        model: 'something',
                    },
                };
            };
        /**
         * Método que simula a definição da página base
         */
        /**
         * Método que simula a definição da página base
         * @return {?}
         */
        NavMock.prototype.setRoot = /**
         * Método que simula a definição da página base
         * @return {?}
         */
            function () {
                return true;
            };
        /**
         * Método que simula o registro de um Nav
         * nav
         */
        /**
         * Método que simula o registro de um Nav
         * nav
         * @param {?} nav
         * @return {?}
         */
        NavMock.prototype.registerChildNav = /**
         * Método que simula o registro de um Nav
         * nav
         * @param {?} nav
         * @return {?}
         */
            function (nav) {
                return;
            };
        return NavMock;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Esta classe simula a classe SplashScreen e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: SplashScreen, useClass: SplashScreenMock},
     *   ...
     * ]
     * ```
     */
    var /**
     * Esta classe simula a classe SplashScreen e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: SplashScreen, useClass: SplashScreenMock},
     *   ...
     * ]
     * ```
     */ SplashScreenMock = /** @class */ (function (_super) {
        __extends(SplashScreenMock, _super);
        function SplashScreenMock() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * Método que simula o evento para esconder o 'splash'
         */
        /**
         * Método que simula o evento para esconder o 'splash'
         * @return {?}
         */
        SplashScreenMock.prototype.hide = /**
         * Método que simula o evento para esconder o 'splash'
         * @return {?}
         */
            function () {
                return;
            };
        return SplashScreenMock;
    }(ngx$1.SplashScreen));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Esta classe simula a classe StatusBar e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: StatusBar, useClass: StatusBarMock},
     *   ...
     * ]
     * ```
     */
    var /**
     * Esta classe simula a classe StatusBar e é utilizada
     * para os testes unitários automatizados
     * ```typescript
     * // Utilizar como provider
     * providers: [
     *   { provide: StatusBar, useClass: StatusBarMock},
     *   ...
     * ]
     * ```
     */ StatusBarMock = /** @class */ (function (_super) {
        __extends(StatusBarMock, _super);
        function StatusBarMock() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * Método que simula o retorno do estilo padrão
         */
        /**
         * Método que simula o retorno do estilo padrão
         * @return {?}
         */
        StatusBarMock.prototype.styleDefault = /**
         * Método que simula o retorno do estilo padrão
         * @return {?}
         */
            function () {
                return;
            };
        return StatusBarMock;
    }(ngx.StatusBar));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que contém serviços simulados necessários para o desenvolvimento
     * de testes unitários automatizados utilizando ionic
     */
    var MockModule = /** @class */ (function () {
        function MockModule() {
        }
        MockModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [],
                        exports: [],
                        providers: [
                            // { provide: DeepLinker, useClass: DeepLinkerMock},
                            { provide: angular.NavParams, useClass: NavParamsMock },
                            // { provide: Nav, useClass: NavMock },
                            { provide: angular.Platform, useClass: PlatformMock },
                            { provide: ngx$1.SplashScreen, useClass: SplashScreenMock },
                            { provide: ngx.StatusBar, useClass: StatusBarMock }
                        ]
                    },] }
        ];
        return MockModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Create async observable that emits-once and completes
     *  after a JS engine turn
     * @template T
     * @param {?} data
     * @return {?}
     */
    function asyncData(data) {
        return rxjs.defer(( /**
         * @return {?}
         */function () { return Promise.resolve(data); }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Aguardar o espaço de tempo de um quadro na quantidade de quadros/seg
     * desejada para que o ionic renderize corretamente os componentes em tela
     * \@example
     * it('Deveria renderizar', async () => {
     *   await component.ngOnInit();
     *   await render(fixture);
     *   expect(fixture.nativeElement.querySelector('#id').value).toBe('Valor');
     * });
     *
     * @template T
     * @param {?} fixture Referência do componente de teste
     * @param {?=} fps Quantidade de quadros por segundo para referência
     * @return {?}
     */
    function render(fixture, fps) {
        if (fps === void 0) {
            fps = 30;
        }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fixture.detectChanges();
                        return [4 /*yield*/, fixture.whenRenderingDone()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fixture.whenStable()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, totvsLogBaseFoundation.UtilsFn.sleep(1000 / fps)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.PlatformMock = PlatformMock;
    exports.EmptyMock = EmptyMock;
    exports.DeepLinkerMock = DeepLinkerMock;
    exports.NavParamsMock = NavParamsMock;
    exports.NavMock = NavMock;
    exports.SplashScreenMock = SplashScreenMock;
    exports.StatusBarMock = StatusBarMock;
    exports.MockModule = MockModule;
    exports.asyncData = asyncData;
    exports.render = render;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-test-utils.umd.js.map