import { PipeTransform } from '@angular/core';
import { I18nBaseService } from 'totvs-log-base-foundation';
/**
 * Pipe de internacionalização da aplicação
 */
export declare class I18NPipe implements PipeTransform {
    private i18nService;
    /**
     * Método construtor que inicializa a classe
     * i18nService Serviço de internacionalização
     */
    constructor(i18nService: I18nBaseService);
    /**
     * Método responsável pela transformação da string
     * query
     * data
     */
    transform(query: string, data: any[]): string;
    /**
     * Método responsável por retornar o que está em cache
     * query
     * args
     */
    private cached;
}
