import { Entry } from '@ionic-native/file/ngx';
/**
 * Interface com informações sobre o arquivo copiado
 * (utilizado no mapeamento do resultado do método 'copyFile')
 */
export interface IFileCopied {
    /** Path do arquivo origem */
    sourcePath: string;
    /** Nome do arquivo origem */
    sourceFileName: string;
    /** Arquivo copiado */
    targetFile: Entry;
}
