import { ImagePickerOptions } from '@ionic-native/image-picker/ngx';
/**
 * Interface que define as propriedades e comportamentos do
 * utilitário de galeria
 */
export interface IImagePickerUtil {
    /**
     * Método responsável por abrir o seletor de imagens e retornar o caminho dos arquivos salvos no cache
     * opt Customização das opções enviadas ao seletor de images
     * Lista de imagens escolhidas
     */
    chooseImage(opt?: ImagePickerOptions): Promise<any>;
}
