import { OidcCordovaPopupWindow } from './oidc-cordova-popup-window';
import { InAppBrowser } from '@ionic-native/in-app-browser/ngx';
import { Events } from '@ionic/angular';
/**
 * Classe responsável pela navegação com popup utilizado no processo
 * de autenticação com Oidc no Ionic
 */
export declare class OidcCordovaPopupNavigator {
    private iab;
    private events;
    /**
     * Método construtor que inicializa a classe
     * iab Serviço do plugin nativo InAppBrowser
     */
    constructor(iab: InAppBrowser, events: Events);
    /**
     * Método que prepara a janela de popup
     * params Parâmetros para a janela de popup
     */
    prepare(params: any): Promise<OidcCordovaPopupWindow>;
}
