/**
 * Interface da janela de Popup utilizado no processo
 * de autenticação com Oidc no Ionic com a definição dos métodos
 * utilizados no Oidc
 */
export interface IOidcCordovaPopupWindow {
    /**
     * Método que realiza a navegação
     * navigatorParams Parâmetros para a navegação
     */
    navigate(navigatorParams: any): void;
    /**
     * Método responsável por fechar a janela
     */
    close(): void;
}
