/**
 * Interface que define as propriedades e comportamentos do
 * utilitário de reconhecimento de voz
 */
export interface ISpeechRecognitionUtil {
    /**
     * Método responsável por habilitar o reconheicimento de voz
     * Lista com os textos reconhecidos (geralmente o primeiro item é o mais provável)
     */
    listening(): Promise<string[]>;
}
