import { SQLiteObject } from '@ionic-native/sqlite/ngx';
/**
 * Interface de uma representação de conexão de banco SqLite gerenciada
 */
export interface ISqLiteConn {
    /**
     * O nome do banco
     */
    name: string;
    /**
     * O local interno do banco
     */
    location: string;
    /**
     * O objeto de conexão
     */
    conn: SQLiteObject;
}
