import { ISyncEntity } from './sync-entity.interface';
/**
 * Estado de sincronização da entidade
 */
export interface ISyncEntityState {
    /**
     * A entidade em questão
     */
    entity: ISyncEntity;
    /**
     * O estado atual da versão
     */
    entityVersion: string;
    /**
     * Se para essa entidade está ocorrendo o sincronismo
     */
    isSyncing: boolean;
}
