/**
 * Esta classe simula a classe NavParams e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: NavParams, useClass: NavParamsMock},
 *   ...
 * ]
 * ```
 */
export declare class NavParamsMock {
    /**
     * Parâmetro de retorno
     */
    static returnParam: any;
    /**
     * Método que simula a definição de parâmetros
     * value
     */
    static setParams(value: any): void;
    /**
     * Método que simula o retorno do valor de uma chave
     * key
     */
    get(key: any): any;
}
