import { SplashScreen } from '@ionic-native/splash-screen/ngx';
/**
 * Esta classe simula a classe SplashScreen e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: SplashScreen, useClass: SplashScreenMock},
 *   ...
 * ]
 * ```
 */
export declare class SplashScreenMock extends SplashScreen {
    /**
     * Método que simula o evento para esconder o 'splash'
     */
    hide(): void;
}
